﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Net.Sockets;
using System.Net;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace WinFileReceiver
{
    public partial class Form1 : Form
    {
        const int PACKSZ = 4096;

        const byte firstbyte = 0x0a;
        const byte secondbyte = 0x0d;
        const byte thirdbyte = 0xff;

        const int MSG_INT = 100;
        const int MSG_STR = 101;

        int filename_dup_index = 9990;

        private AGauge[] aGauge = null;
        int aGaugeIndex = -1;

        public Form1()
        {
            InitializeComponent();

            aGauge = new AGauge[]
            {
                aGauge1,
                aGauge2,
                aGauge3,
                aGauge4,
                aGauge5,
                aGauge6,
                aGauge7,
                aGauge8,
                aGauge9,
                aGauge10,
                aGauge11,
                aGauge12,
            };
        }

        /*private void timer1_Tick(object sender, EventArgs e)
        {
            aGauge4.Value += 10;

            if (aGauge4.Value >= 300)
            {
                aGauge4.Value = -300;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (aGauge4.NeedleType == 0)
            {
                aGauge4.NeedleType = 1;
            }
            else
            {
                aGauge4.NeedleType = 0;
            }
        }*/

        private void DisplayTat(int TotalSize, int CurSize, int index)
        {
            int percentage = -300 + Convert.ToInt32(Convert.ToDouble(CurSize) / Convert.ToDouble(TotalSize) * 600.0);
            int percentageTxt = Convert.ToInt32(Convert.ToDouble(CurSize) / Convert.ToDouble(TotalSize) * 100.0);

            panel1.Invoke(new MethodInvoker(delegate
            {
                //

                if (percentage > 300) aGauge[index].Value = 300;
                else
                {
                    aGauge[index].Value = percentage;
                    //mmTxt.Text = percentageTxt.ToString("000");

                    aqGauge1.Value = percentage * 1.0F;
                }

            }));
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            Thread ListenThread = new Thread(new ThreadStart(Init));
            ListenThread.Start();
        }

        protected override bool ProcessCmdKey(ref Message message, Keys keyData)
        {
            const int WM_KEYDOWN = 0x0100;

            switch (message.Msg)
            {
                case WM_KEYDOWN:
                    if (keyData.ToString() == "Escape")
                    {
                        //ListenThread.Abort();
                        //RealSocModel.Abort();

                        Application.ExitThread();
                        Environment.Exit(0);
                    }
                    break;
                default:
                    break;
            }
            return base.ProcessCmdKey(ref message, keyData);
        }

#if(true)
        string get_filenm_recv(Socket handler)
        {
            byte[] bytes = new byte[PACKSZ];
            byte[] data_ = new byte[PACKSZ];
            int datalen_ = 0;
            int ff;

            string filenm = "";

            try
            {

                datalen_ = 0;
                while (true)
                {
                    int recv_len = handler.Receive(bytes);

                    ff = 0;

                    if (recv_len > 0)
                    {
                        for (int ii = 0; ii < recv_len; ii++)
                        {
                            data_[datalen_] = bytes[ii];
                            datalen_ = datalen_ + 1;

                            if (datalen_ > (2 + 2) && (bytes[datalen_ - 1]) == thirdbyte && (bytes[datalen_ - 2]) == secondbyte && (bytes[datalen_ - 3]) == firstbyte)
                            {
                                ff = 100;
                                break;
                            }
                        }
                        if (ff == 100) break;
                    }
                    else break;
                }

                filenm = Encoding.UTF8.GetString(data_, 0, datalen_ - 3);
                //richTextBox1.Text = //richTextBox1.Text + "filenm:[" + filenm + "]" + "\n";
            }
            catch (Exception e)
            {
                //
            }

            return (filenm);
        }

        int get_filesz_recv(Socket handler)
        {
            byte[] bytes = new byte[PACKSZ];
            byte[] data_ = new byte[PACKSZ];
            int datalen_ = 0;
            int ff = 0;

            string filesznm = "";
            int ____filesze = 0;

            try
            {
                datalen_ = 0;
                while (true)
                {
                    int recv_len = handler.Receive(bytes);

                    ff = 0;

                    if (recv_len > 0)
                    {
                        for (int ii = 0; ii < recv_len; ii++)
                        {
                            data_[datalen_] = bytes[ii];
                            datalen_ = datalen_ + 1;

                            if (datalen_ > (2 + 2) && (bytes[datalen_ - 1]) == thirdbyte && (bytes[datalen_ - 2]) == secondbyte && (bytes[datalen_ - 3]) == firstbyte)
                            {
                                ff = 100;
                                break;
                            }
                        }
                        if (ff == 100) break;
                    }
                    else break;
                }
                filesznm = Encoding.UTF8.GetString(data_, 0, datalen_ - 3);
                ____filesze = Convert.ToInt32(filesznm);
            }
            catch (Exception e)
            {
                //
            }

            return (____filesze);
        }
#endif

#if(false)
        var get_message_recv(Socket handler, int type)
        {
            byte[] bytes = new byte[PACKSZ];
            byte[] data_ = new byte[PACKSZ];
            int datalen_ = 0;
            int ff;

            string filenm = "";

            try
            {

                datalen_ = 0;
                while (true)
                {
                    int recv_len = handler.Receive(bytes);

                    ff = 0;

                    if (recv_len > 0)
                    {
                        for (int ii = 0; ii < recv_len; ii++)
                        {
                            data_[datalen_] = bytes[ii];
                            datalen_ = datalen_ + 1;

                            if (datalen_ > (2 + 2) && (bytes[datalen_ - 1]) == thirdbyte && (bytes[datalen_ - 2]) == secondbyte && (bytes[datalen_ - 3]) == firstbyte)
                            {
                                ff = 100;
                                break;
                            }
                        }
                        if (ff == 100) break;
                    }
                    else break;
                }

                filenm = Encoding.UTF8.GetString(data_, 0, datalen_ - 3);
                //richTextBox1.Text = //richTextBox1.Text + "filenm:[" + filenm + "]" + "\n";
            }
            catch (Exception e)
            {
                //
            }
            
            if(type == MSG_INT) return (Convert.ToInt32(filenm));
            else if(type == MSG_STR) return (filenm);
        }
#endif

        void ByteToFile(ref FileStream file, byte[] source, int sourcelen)
        {
            if (true)
            {
                file.Write(source, 0, sourcelen);
            }
        }
        void SocketRunHandler(Object tmphandler)
        {
            byte[] bytes = new byte[PACKSZ];
            int cur = 0;
            FileStream file = null;
            int displayIndex = aGaugeIndex;

            Socket handler = (Socket)tmphandler;

            try
            {
                int filesz = get_filesz_recv(handler);
                Console.WriteLine("filesz:" + filesz.ToString());

                DateTime now = DateTime.Now;

                filename_dup_index++;
                filename_dup_index = filename_dup_index % 9999;

                string filename = now.ToString("yyyyMMddHHmmss") + "_" + filename_dup_index.ToString("0000") + "_" + get_filenm_recv(handler);
                Console.WriteLine("filename:" + filename.ToString());

                file = new FileStream(filename, FileMode.Create);

                cur = 0;

                while (true)
                {
                    int sz = handler.Receive(bytes);
                    Console.WriteLine(filename + "- real filesz:" + sz.ToString());

                    if (sz == -1)
                    {
                        break;
                    }

                    cur += sz;

                    ByteToFile(ref file, bytes, sz);
                    DisplayTat(filesz, cur, displayIndex);

                    if (cur > filesz)
                    {
                        break;
                    }
                    else if (filesz == cur)
                    {
                        break;
                    }
                }
                if (file != null) file.Close();
                if (handler != null) handler.Close();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }

            panel1.Invoke(new MethodInvoker(delegate
            {
                //
            }));
        }
        private void Init()
        {
            panel1.Invoke(new MethodInvoker(delegate
            {
                //
                for (int kk = 0; kk < aGauge.Length; kk++)
                {
                    aGauge[kk].Value = -300;
                }

                //int percentageTxt = 0;
                //mmTxt.Text = percentageTxt.ToString("000");

            }));

            //소켓 객체 생성 (TCP 소켓)
            Socket listener = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            //엔드포인트에 소켓 바인드(Bind)
            IPEndPoint localEndPoint = new IPEndPoint(IPAddress.Parse("127.0.0.1"), 21111);
            listener.Bind(localEndPoint);

            //Listen소켓의 대기열의 길이를 설정합니다.
            listener.Listen(10);

            //richTextBox1.Text = //richTextBox1.Text + "[waiting for a connection]" + "\n";

            while (true)
            {
                try
                {
                    //Console.WriteLine("[Information][Accept Possible]");
                    //richTextBox1.Text = //richTextBox1.Text + "[Information][Accept Possible]" + "\n";

                    Socket handler = listener.Accept();

                    aGaugeIndex++;
                    if (aGaugeIndex == 12) aGaugeIndex = 0;

                    panel1.Invoke(new MethodInvoker(delegate
                    {
                        //
                        aGauge[aGaugeIndex].Value = -300;

                        //int percentageTxt = 0;
                        //mmTxt.Text = percentageTxt.ToString("000");
                        listBox1.Items.Add("[" + aGaugeIndex.ToString("0000") + "]:(" + handler.Handle.ToString() + ")");

                    }));

                    Thread RealSocModel = new Thread(new ParameterizedThreadStart(SocketRunHandler));
                    RealSocModel.Start(handler);
                }
                catch (Exception ex)
                {
                    //
                }
            }

            listener.Close();
        }
    }
}
